{Tdirtree Component for Delphi 2  written by Markus Stephany
                                             MirBir.St@T-Online.de
                                             MirBir.St@Saargate.de
                                             http://home.t-online.de/home/mirbir.st/

 V 1.14    february 02 1998


credits to all the people who reported bugs and suggestions to me,
especially to Feng Ting, Davendra Patel, Yuval Perlov, Doug Hay, botevi@bu.omega.bg, Sebastian Hildebrandt, Heiko Webers
and all the others i forgot now...



 // a treeview that shows the system's drives and folders (or a part of them ,s.b.)
 // displays explorer-like icons and filenames

 this is free for freeware, public domain and shareware, but not for commercial use
 without my permission.

 if something is going wrong (or even not), contact me (see above), but do not make
 me responsable for anything !!

 added properties :
 Directory      read/write    gets/sets the dirtree's directory
 Drive          read/write    gets/sets the drive (restoring the previously used
                                                   directory for that drive)

 added functions :
 Reload                       reads the items again and tries to set the old dir.
                              (use it e.g. with a shell-notification)

 added event :
 OnAddDir (Filename : string ; var DoAdd : boolean)
                              You can use this event to decide whether to add
                              a drive/path or not (see the sample for more info)

 revision 1.02:
 now it runs a bit faster at startup.
 added property :
 ReadOnStart :                Now You can decide whether the control should read
                              the directories on creation or explicit by calling
                              Reload

 revision 1.1:
 now it should run under NT without getting asked to insert a floppy disk or cd-rom
 added properties:

 DirType :                    You can set the file-attributes to decide which directories
                              to show (this works not for the drive-items (cause of NT))

 ShellIcons (readonly) :      an imagelist where you can read the shell's small-icons
                              (maybe for a listview for files, you have not to create
                              another imagelist for small icons)

 AllowNetwork  :              enables/disables displaying of network-drives

 revision 1.11:
 uses ...forms... was missed by some people (and i can understand them)
 i hope that there are not longer problems under delphi3 and delphi 2.00 and windows nt,
 oh, i hope it so !

 revision 1.12:
 a bug is fixed when using a "real" network-drive ('\\blabla...')
 added property:

 DropDirectory :              is something is dropped to tdirtree, this property
                              gives you the directory of the droptarget-node
 GoBelowRecycleBin :          if set to false, don't show subdirectories of the
                              recycle bin-folders

 revision 1.13:
 added function:

 GetNodefromPath(dir:string):ttreenode : returns the node which belongs to the
                                         specified path (if existing in the items);

 revision 1.14: 
 property-name items changed to Items (because of the case sensitivity of bcb)
 thanks to keith speers kspeers@ms5.hinet.net for this bug-report
 
 added procedure: (thanks to ashley bass abass@iname.com for his suggestions)

 RenamePart(oldpath,newname:string); rename the node belonging to the give path and correct the children
 DeletePart(dpath:string); deletes the node belonging to the path and all its kids;
 AddPath(expath,newsub:string); adds a new sub dir to the children of the existing path expath
 }

unit dirtree;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls,
  ComCtrls,shellapi,filectrl{,shlobj},forms;

type taddfileevent = procedure (Filename : string ; var DoAdd : boolean) of object;

tdirattr = (dtReadonly, dtHidden, dtSystem, dtArchive, dtNormal, dtAll);


tDirType = set of tdirattr;

TDirRec = record
        Attr : integer;
        Name : TFilename;
        Handle:integer;
        Data  : twin32finddata;
end;


//TFileType = set of TFileAttr;

type
    tdirname = class(tobject)
    public
          Name : string;
          isexp    : boolean;
end;


type
  Tdirtree = class(TcustomTreeView)
  private
    { Private-Deklarationen }
    filist : timagelist;
    factdirs : array['A'..'Z'] of string;
    fonadd : taddfileevent;
    fondeletion : ttvexpandedevent;
    ftdirs : tstringlist;
    fifols : integer ;
    fifoln : integer ;
    freadonstart : boolean;
    fallowchange : boolean;
    fdirtype : tdirtype;
    fnetall  : boolean;
    fbelbin  : boolean;
    procedure delitem (Sender: TObject; Node: TTreeNode);
  protected
    { Protected-Deklarationen }
    function CanExpand(Node: TTreeNode): Boolean ; override;
    function okay (attr:integer):boolean;
    procedure createwnd ; override;
    procedure readnew;
    destructor destroy; override;
    procedure addnode (par : ttreenode; var item : ttreenode; a : string);
//    procedure getbtn (var item : ttreenode);
    function addkid (par:ttreenode; a : string):ttreenode;
    procedure getsubkids (par:ttreenode);
    function getdirectory : string;
    function getdrive : char;
    procedure setdrive (val : char);
    procedure setdirectory (val : string);
    procedure setdirtype (val :tdirtype);
    function askadd (fnam : string):boolean;
    procedure Change(Node: TTreeNode); override;
    procedure setnetallow (val : boolean);
    property Items stored false;
    function getdropdir:string;
    procedure setbelbin(val:boolean);
    function findfirstdir(path:tfilename;var rec:tdirrec):integer;
    function findnextdir(var rec:tdirrec):integer;

  public
    { Public-Deklarationen }
//    fnamen : tstrings;
    procedure getbtn (var item : ttreenode);
    procedure Reload ;
    constructor create (aowner: tcomponent);override;
    procedure FullExpand;
    procedure getkids (var item : ttreenode);
    function GetNodeFromPath(path:string):ttreenode;
    property Drive : char read getdrive write setdrive;
//    property Pathes : tstringlist read ftdirs;
    property DropDirectory : string read getdropdir;
    procedure RenamePart (oldpath,newname:string);
    procedure DeletePart (dpath:string);
    procedure AddPath(expath,newsub:string);
  published
    { Published-Deklarationen }
    property Directory : string read getdirectory write setdirectory;
    property OnAddDir : taddfileevent read fonadd write fonadd;
    property OnDeleteItem : ttvexpandedevent read fondeletion write fondeletion;
    property BorderStyle;
    property ReadOnStart : boolean read freadonstart write freadonstart;
    property DragCursor;
    property ShellIcons : timagelist read filist;
    property DirType   : TDirtype read fdirtype write setdirtype;
    property AllowNetwork : boolean read fnetall write setnetallow;
    property GoBelowRecycleBin : boolean read fbelbin write setbelbin;
    property Readonly;
    property DragMode;
    property HideSelection;
    property OnEditing;
    property OnEdited;
    property OnExpanding;
    property OnExpanded;
    property OnCollapsing;
    property OnCollapsed;
    property OnChanging;
    property OnChange;
    property Align;
    property Enabled;
    property Font;
    property Color;
    property ParentColor;
    property ParentCtl3D;
    property Ctl3D;
    property TabOrder;
    property TabStop default True;
    property Visible;
    property OnClick;
    property OnEnter;
    property OnExit;
    property OnDragDrop;
    property OnDragOver;
    property OnStartDrag;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnDblClick;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property PopupMenu;
    property ParentFont;
    property ParentShowHint;
    property ShowHint;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Merkes'' Pages', [Tdirtree]);
end;


procedure adirname(a:ttreenode;b:string;c:boolean);
var d : tdirname;
begin
     d:=tdirname.create;
     d.isexp := c;
     d.name := b;
     a.data:=D;
end;

function DiskinDrive(lw: char): boolean;
// credits : this code comes from Sebastian Hildebrandt <hildebrandt@t0.or.at>
var sRec : TSearchrec;
    i : integer;
    root : string;
    Vol_NameBuffer,
    FileSystemNameBuffer : PChar;
    FileSystemFlags,
    Max_ComponentLength : DWORD;
begin
  result:=false;
  root := lw + ':\';
  Vol_NameBuffer := StrAlloc(256);
  FileSystemNameBuffer := StrAlloc(256);
  // Bei dieser Pruefung kommt keine Meldung (ist wohl nur unter NT notwendig, und nur bei Diskettenlaufwerken)
  if GetVolumeInformation(PChar(root), Vol_NameBuffer, 255, Nil, Max_ComponentLength,
                   FileSystemFlags, FileSystemNameBuffer, 255)
  then begin
    i := FindFirst(root + '*.*', faanyfile, SRec);
    FindClose(SRec);
    if i = 0 then result:=true;
  end; // else showmessage('Keine Diskette eingelegt');

  StrDispose(Vol_NameBuffer);
  StrDispose(FileSystemNameBuffer);
end;

constructor tdirtree.create;
var sfi : tshfileinfo;
     n : char;
begin
     inherited create(aowner);
     filist := timagelist.create(self);
     ondeletion := delitem;
//     fnamen := tstringlist.create;
     ftdirs := tstringlist.create;
     freadonstart := true;
     fbelbin := true;
     for n := 'A' to 'Z' do
         factdirs[n]:=uppercase(n)+':\';
     try
        factdirs[upcase(getcurrentdir[1])] := uppercase(getcurrentdir);
        filist.handle :=
          shgetfileinfo('',0,sfi,sizeof(tshfileinfo),
            shgfi_sysiconindex or shgfi_smallicon);
        filist.shareimages := true;
        images := filist;
     except;
     end;
//     readonly := true;
     sorttype := stnone;
     hideselection := false;
     fallowchange := false;
     fdirtype := [dtAll,dtNormal];
     fnetall := true;
end;

destructor tdirtree.destroy;
begin
     fallowchange := false;
//     fnamen.free;
     ftdirs.free;
     filist.free;
     inherited;
end;

procedure tdirtree.setbelbin(val:boolean);
begin
     if fbelbin <> val then begin
        fbelbin:=val;
        reload;
     end;
end;


function tdirtree.getdropdir:string;
begin
     result := '';
     try
        if droptarget <> nil
//        then result := copy(fnamen[integer(droptarget.data)],2,maxint);
        then result := tdirname(droptarget.data).name;
//        then  tdirrec(droptarget.data);
     finally
     end;
end;

procedure tdirtree.Reload ;
var t : char;
    node,nd1 : ttreenode;
    tdir : string;
begin
     tdir := getdirectory;
     readnew;
     setdirectory(tdir);
     if items.count > 0 then if selected = nil then setdirectory(copy(tdir,1,3));
     if items.count > 0 then if selected = nil then begin
        node := items.getfirstnode;
        nd1 := node.getfirstchild;
        while (nd1 <> nil) and (nd1.text = 'u**') and (node.getnextsibling <> nil) do begin
               node := node.getnextsibling;
               nd1 := node.getfirstchild;
        end;
        t := upcase(tdirname(node.data).name[1]);
            try
               setdirectory(factdirs[t]);
               if getdirectory <> factdirs[t] then begin
                  node.selected := true;
                  change(node);
               end;
            except
            end;
     end;
end;




function tdirtree.okay (attr:integer):boolean;
// check if the dir-attributes fit to the mask
begin
     result := false;
     if dtall in fdirtype then result := true else begin
        if (attr and fahidden) = fahidden then
           if not (dthidden in fdirtype) then exit;
        if (attr and fasysfile) = fasysfile then
           if not (dtsystem in fdirtype) then exit;
        if (attr and faarchive) = faarchive then
           if not (dtarchive in fdirtype) then exit;
        result := true;
        if dtnormal in fdirtype then exit;
        if (attr and (fahidden or fasysfile or faarchive)) = 0 then result := false;
     end;
end;


function tdirtree.askadd (fnam : string):boolean;
var c : integer;
begin
     result := true;
     // allowed to go below rycle-bin ?
     if not fbelbin then begin
        c:= pos('\recycled\',ansilowercase(fnam));
        if c > 0 then  if c < (length(fnam) -9) then result:=false;
     end;
     if result and assigned (fonadd) then fonadd(fnam,result);
end;

procedure tdirtree.setdirtype (val :tdirtype);
begin
     if val <> fdirtype then begin
        fdirtype := val;
        reload;
     end;
end;

procedure tdirtree.setnetallow (val : boolean);
begin
     if val <> fnetall then begin
        fnetall := val;
        reload;
     end;
end;

procedure tdirtree.setdirectory (val : string);
var az : integer;
    node : ttreenode;
    oldcur : tcursor;
    afg : integer;
    tsr : string;
    label m1;

    function azpos(a:string):integer;
    var ct: integer;
    begin
         result := 0;
         repeat
               ct := pos ('\',a);
               if ct = 0 then exit;
               inc (result,1);
               a:=copy(a,ct+1,maxint);
         until false;
    end;

    function getpart(a:string;b:integer):string;
    var ct,ix : integer;
    begin
         result := a;
         ix := 0;
         for ct := 1 to length(a) do begin
             if a[ct] = '\' then inc (ix,1);
             if ix = b then begin
                result := copy(a,1,ct);
                exit;
             end;
         end;
    end;

    function getroot(a:string):ttreenode;
    var sr : ttreenode;
    begin
         result:=nil;
         sr := items.getfirstnode;
         while sr <> nil do begin
               if lstrcmpi(pchar(a),pchar(tdirname(sr.data).name)) = 0 then begin
                     if not tdirname(sr.data).isexp then getkids(sr);
                     result:=sr;
                     break;
               end;
               sr := sr.getnextsibling;
         end;
    end;

    function getchi(c:ttreenode;a:string):ttreenode;
    var sr : ttreenode;
    begin
         result:=nil;
         sr := c.getfirstchild;
         while sr <> nil do begin
               if lstrcmpi(pchar(a),pchar(tdirname(sr.data).name)) = 0 then begin
                     if not tdirname(sr.data).isexp then getkids(sr);
                     result:=sr;
                     break;
               end;
               sr := c.getnextchild(sr);
         end;
    end;

begin
     if val = '?' then exit;
     if val <> '' then if val[length(val)] <> '\' then val := val+'\';
     //if ansicomparetext(val,getdirectory) = 0 then exit;
     if length(val) <> 3 then if not directoryexists(copy(val,1,length(val)-1)) then exit;
     // teilstrings holen
     az := azpos(val);
     if az = 0 then exit;
     oldcur := screen.cursor;
     screen.cursor := crhourglass;
     items.beginupdate;
     val := uppercase(val);
     for afg := 1 to az do begin
         // string holen
         tsr := getpart(val,afg);
         if afg = 1 then
         // rootnode herausfinden
            node := getroot(tsr)

         // kindnode herausfinden
         else  node := getchi(node,tsr);
         if node = nil then goto m1;
     end;
     selected := node;
     topitem := node;
m1:     items.endupdate;
     screen.cursor := oldcur;
end;

function tdirtree.getdirectory : string;
begin
     if selected = nil then result := '?' else
     try
        result := tdirname(selected.data).name;
     except
           result := '?';
     end;
end;


function tdirtree.addkid (par:ttreenode; a : string):ttreenode;
var sfi : tshfileinfo;
    sr : string;
    item : ttreenode;
begin
     sr := '';
     if par = nil then exit;
     //sr := copy(fnamen[integer(par.data)],2,maxint);
     if a[length(a)] <> '\' then a:=a+'\';
     shgetfileinfo(pchar(sr+a),0,sfi,sizeof(sfi),shgfi_sysiconindex or shgfi_smallicon
       or shgfi_displayname);
//     fnamen.add('u'+uppercase(sr+a));
     item := par.owner.addchild(par,sfi.szdisplayname);
     adirname(item,uppercase(sr+a),false);
//     item.data := pointer(fnamen.count-1);
     item.imageindex := sfi.iicon;
     shgetfileinfo(pchar(sr+a),0,sfi,sizeof(sfi),shgfi_sysiconindex or shgfi_smallicon
       or shgfi_openicon);
     item.selectedindex := sfi.iicon;
     result := item;
end;

procedure tdirtree.addnode (par:ttreenode; var item : ttreenode; a:string);
var sfi : tshfileinfo;
    sr : string;
begin
     sr := '';
     if a[length(a)] <> '\' then a:=a+'\';
     shgetfileinfo(pchar(sr+a),0,sfi,sizeof(sfi),shgfi_sysiconindex or shgfi_smallicon
       or shgfi_displayname);
//     fnamen.add('u'+uppercase(sr+a));
     item := items.add(par,sfi.szdisplayname);
     adirname(item,uppercase(sr+a),false);
//     item.data := pointer(fnamen.count-1);
     item.imageindex := sfi.iicon;
     if sfi.iicon <> fifoln then begin
        shgetfileinfo(pchar(sr+a),0,sfi,sizeof(sfi),shgfi_sysiconindex or shgfi_smallicon
        or shgfi_openicon);
        item.selectedindex := sfi.iicon;
        if length(a) > 3 then begin
           fifoln := item.imageindex;
           fifols := sfi.iicon;
        end;
     end else item.selectedindex := fifols;
end;

procedure tdirtree.getsubkids (par:ttreenode);
var node : ttreenode;
begin
     if csdesigning in componentstate then exit;
     if par = nil then exit;
     node := par.getfirstchild;
     while node <> nil do begin
           getkids(node);
           node := par.getnextchild(node);
     end;
end;

procedure tdirtree.getkids (var item:ttreenode);
var sr : tdirrec;
    res,ct : integer;
    si : boolean;
    cansc : boolean;
    pt : string;
begin
     if csdesigning in componentstate then exit;
     if item = nil then exit;
     cansc := true;
     ftdirs.clear;
     si:=tdirname(item.data).isexp;
     if si then exit;
{     if length(si) = 4 then begin
        nid := item.getfirstchild;
        if nid <> nil then if nid.text = 'u**' then
           cansc := diskindrive(si[2]);
     end;   }
     pt := tdirname(item.data).name;
     item.deletechildren;
     tdirname(item.data).isexp:=true;
     if not cansc then exit;
     fillchar(sr,sizeof(sr),0);
     res := findfirstdir(pt+'*.*',sr);
     while res = 0 do begin
           if ((sr.attr and fadirectory) > 0) and (sr.name <> '.') and (sr.name <> '..') then
              if askadd(pt+sr.name+'\') then if okay(sr.attr)
              then
              ftdirs.add(sr.name);
              //addkid(item,si+sr.name);
           res := findnextdir(sr);
     end;
     windows.findclose(sr.handle);
     ftdirs.sorted := true;
     if ftdirs.count > 0 then for ct := 0 to ftdirs.count -1 do
        addkid(item,pt+ftdirs[ct]);
end;

procedure tdirtree.getbtn (var item:ttreenode);
var sr : tdirrec;
    res : integer;
    si : boolean;
    pt : string;
begin
     if csdesigning in componentstate then exit;
     if item = nil then exit;
     si:=tdirname(item.data).isexp;
     pt := tdirname(item.data).name;
     if si then exit;
     res := findfirstdir(pt+'*.*',sr);
     while res = 0 do begin
           if ((sr.attr and fadirectory) > 0) and (sr.name <> '.') and (sr.name <> '..') then
              if askadd(pt+sr.name+'\') then if
              okay(sr.attr) then begin
                 items.addchild(item,' ');
                 break;
              end;
           res := findnextdir(sr);
     end;
     windows.findclose(sr.handle);
end;

procedure tdirtree.readnew;
var oldcur : tcursor;
    node : ttreenode;
    ct : integer;
    drv : char;
    bits : set of 0..25;

    function driveexists(db:byte):boolean;
    // i hope this works on nt, too !!
    var dr : char;
    begin
         //
         result := false;
         if not (ct in bits) then exit;
         dr := char(db+ord('A'));
         if not fnetall then if getdrivetype(pchar(dr+':\')) = drive_remote then exit;
         result := true;

    end;
begin
     if handleallocated then if not (csloading in componentstate) then begin
          fallowchange := false;
          oldcur := screen.cursor;
          screen.cursor := crhourglass;
//          fnamen.clear;
          items.beginupdate;
          items.clear;
          application.processmessages;
          // Laufwerke einlesen
          integer(bits):=getlogicaldrives;
          for ct := 0 to 25 do
              if driveexists(ct) then begin
                  drv := char (ct+ord('A'));
                  if askadd(drv+':\') then begin
                     addnode(nil,node,drv+':\');
                        case getdrivetype(pchar(drv+':\')) of
                             0,1,drive_removable,drive_cdrom :items.addchild(node,'u**');

                        else getbtn(node);
                        end;
                     //getkids(node);
                     //getsubkids(node);
                  end;
              end;
          fallowchange := true;
          items.endupdate;
          topitem := selected;
          screen.cursor := oldcur;
     end;
end;

procedure tdirtree.createwnd ;
begin
     inherited;
     if freadonstart then readnew;
end;

function tdirtree.CanExpand(Node: TTreeNode): Boolean ;
var oldcur : tcursor;
begin
     oldcur := screen.cursor;
     screen.cursor := crhourglass;
     getkids(node);
     getsubkids(node);
     screen.cursor := oldcur;
     result := inherited CanExpand(Node);
end;

procedure tdirtree.Change(Node: TTreeNode);
var sr : string;
begin
     if not (csdestroying in componentstate) then
     if fallowchange then begin
        if node <> nil then
            begin
              sr := uppercase( tdirname(node.data).name);
              try
                 factdirs[sr[1]] := sr;
              except
              end;
           end;
        inherited change (node);
     end;
end;

procedure Tdirtree.FullExpand;
var oldcur : tcursor;
var
  Node: TTreeNode;
begin
     oldcur := screen.cursor;
     screen.cursor := crhourglass;
  Node := Items.GetFirstNode;
  while Node <> nil do
  begin
    Node.Expand(True);
    Node := Node.GetNextSibling;
  end;
     screen.cursor := oldcur;
end;

procedure tdirtree.setdrive (val : char);
var sr : string;
begin
     if upcase(val) = upcase (getdirectory[1]) then exit;
     try
        sr := factdirs[upcase(val)];
        if not directoryexists(sr) then sr := copy(sr,1,3);
        setdirectory(sr);
     except
     end;
end;

function tdirtree.getdrive : char;
begin
     result := upcase(getdirectory[1]);
end;

function tdirtree.GetNodeFromPath(path:string):ttreenode;
var az : integer;
    node : ttreenode;
    oldcur : tcursor;
    afg : integer;
    tsr : string;
    label m1;

    function azpos(a:string):integer;
    var ct: integer;
    begin
         result := 0;
         repeat
               ct := pos ('\',a);
               if ct = 0 then exit;
               inc (result,1);
               a:=copy(a,ct+1,maxint);
         until false;
    end;

    function getpart(a:string;b:integer):string;
    var ct,ix : integer;
    begin
         result := a;
         ix := 0;
         for ct := 1 to length(a) do begin
             if a[ct] = '\' then inc (ix,1);
             if ix = b then begin
                result := copy(a,1,ct);
                exit;
             end;
         end;
    end;


    function gnd(c:ttreenode;a:string):ttreenode;
    var sr : ttreenode;
    begin
         result := nil;
         if items.count = 0 then exit;
         if c <> nil then
            sr := c.getfirstchild
         else sr := items[0];
         while sr <> nil do begin
               if tdirname(sr.data).name = a then begin
                  result := sr;
                  exit;
               end;
               sr := sr.getnextsibling;
         end;
    end;

begin
     result := nil;
     if path <> '' then if path[length(path)] <> '\' then path := path+'\';
     // teilstrings holen
     az := azpos(path);
     if az = 0 then exit;
     oldcur := screen.cursor;
     screen.cursor := crhourglass;
     path := uppercase(path);
     node := nil;
     for afg := 1 to az do begin
         // string holen
         tsr := getpart(path,afg);
         node := gnd(node,tsr);
         if node = nil then begin
            screen.cursor := oldcur;
            exit;
         end;
     end;
     result := node;
     screen.cursor := oldcur;
end;

function tdirtree.findfirstdir(path:tfilename;var rec:tdirrec):integer;

begin
     with rec do begin
          fillchar(rec,sizeof(tdirrec),0);
          handle:=findfirstfile(pchar(path),data);
          if handle <> invalid_handle_value then begin
             result := 0;
             attr := data.dwfileattributes;
             name := data.cfilename;
          end else result := getlasterror;
     end;
end;

function tdirtree.findnextdir(var rec:tdirrec):integer;
begin
     with rec do begin
          if findnextfile(handle,data) then begin
             result := 0;
             attr := data.dwfileattributes;
             name := data.cfilename
          end else result := getlasterror;
     end;
end;

procedure tdirtree.delitem (Sender: TObject; Node: TTreeNode);
begin
     tdirname(node.data).free;
     if assigned(fondeletion) then fondeletion(sender,node);
end;

procedure tdirtree.RenamePart (oldpath,newname:string);
var n : ttreenode;

   procedure renamenodeandkids(n:ttreenode);
   var sfi : tshfileinfo;
       oldsr : string;
       n1 : ttreenode;
   begin
        // zuerst neues icon und dispname fr n holen
        oldsr := newname+copy(tdirname(n.data).name,length(oldpath)+1,maxint);
        shgetfileinfo(pchar(oldsr),0,sfi,sizeof(sfi),shgfi_sysiconindex or shgfi_smallicon
        or shgfi_displayname);
        n.text := sfi.szDisplayName;
        n.imageindex := sfi.iicon;
        tdirname(n.data).name := oldsr;
        if n = selected then change(n);
        if tdirname(n.data).isexp and n.HasChildren then begin
           n1 := n.GetFirstChild;
           while n1 <> nil do begin
                 renamenodeandkids(n1);
                 n1 := n.getnextchild(n1);
           end;
        end;
   end;

begin
     if newname = '' then exit;
     if oldpath = '' then exit;
     n := getnodefrompath(oldpath);
     if n <> nil then begin
        oldpath := tdirname(n.data).name;
        newname := extractfilepath(copy(oldpath,1,length(oldpath)-1))+newname;
        if newname[length(newname)] <> '\' then newname := newname+'\';
        newname := uppercase(newname);
        renamenodeandkids(n);
     end;
end;

procedure tdirtree.DeletePart (dpath:string);
var n : ttreenode;
begin
     n := getnodefrompath(dpath);
     if n <> nil then items.delete(n);
end;

procedure tdirtree.AddPath(expath,newsub:string);
var n,n1 : ttreenode;
begin
     n := getnodefrompath(expath);
     if n <> nil then n1:=addkid(n,tdirname(n.data).name+newsub);
     getbtn(n1);
     n.AlphaSort;
end;

end.
